		title commandline_args

;Functions to get the programname, argcount and args of commmandline
;needed to pass both the program to execute and the arguments
;to the exec function.

.xlist
include c:\asm\include\macro.inc
.list

std_in_handle		equ	0

max_childname_len	equ	260
max_commandtail_len	equ	261


printstr	macro	stringptr
	lea	dx,	crlf
	mov	ah,	09h
	int	21h
	lea	dx,	stringptr
	int	21h
endm

Code_seg segment public 'code'
	
assume cs:Code_seg,ds:Data_seg, es: Data_seg

public	get_childnm_and_stdcmndline
extrn	error_handling:near		;in incprocs.asm



get_childnm_and_stdcmndline proc	;speciaal voor execute child
;--------------------------------------
;Gets the full qualified programname 
;and the commandline from psp/environ.
;
;Writes:	child_name
;		len_cmndtail
;		commandtail
;------------------------------------
	push	ax
	push	cx
	push	si
	push	di
	push	ds
	xor	cx,	cx
	lea	di,	child_name

;gets psp segment
	mov	ah,	62h		
	int	21h

;get commandline from psp
	mov	ds,	bx
	mov	cl,	byte ptr ds:[80h]	;len commandline
	cmp	cl,	0			;==0 ?
	jz	getuserinput
	mov	si,	81h
	add	cx,	si			;points to end of cmndline
	call 	skip_delimiter			;leading delimiters
childLP:lodsb
	call	test_delimiter	
	jz	donechild
	stosb
	jmp	childLP
donechild:
	mov	al,	0			;append trailing zero
	mov	byte ptr es:[di],al

;get params from psp
	dec	si				;point to delimiter again
	lea	di,	es:[commandtail]	;es[di] to commandtail
	sub	cx,	si			;points to start parms
	mov	byte ptr es:[len_cmndline],cl
	rep 	movsb

	pop	ds
params_done:
	pop	di
	pop	si
	pop	cx
	pop	ax
	ret

getuserinput:
	pop	ds
	call	get_exec_arguments
	jmp	params_done

get_childnm_and_stdcmndline endp

get_exec_arguments	proc
;---------------------------------------
;gets childname and params from user 
;only called in case of no commandline! 
;
;out:	child_name
;	len_commandtail
;	commandtail
;---------------------------------------	
	push	ax
	push	bx
	push	cx
	push	dx	

	printstr	child_mess
	mov	bx,	std_in_handle
	mov	cx,	max_childname_len
	lea	dx,	child_name
	mov	ah,	3fh
	int	21h
	jc	err_read
	mov	bx,	ax
	add	bx,	dx
	mov	byte ptr ds:[bx-2],0
		
	printstr	param_mess
	mov	bx,	std_in_handle
	mov	cx,	max_commandtail_len
	lea	dx,	commandtail
	mov	ah,	3fh
	int	21h
	jc	err_read
	sub	al,	2
	mov	len_cmndline,al
done_read: 
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret

err_read:
	mov	error,	al
	call	error_handling

get_exec_arguments endp

test_delimiter	proc
;------------------------------------		
;Test if al is one of DOS delimiters 
;out: set ZF on delimiter
;------------------------------------
	cmp	al,	' '	
	jz	donetest
	cmp	al,	','
	jz	donetest
	cmp	al,	tab
	jz	donetest
	cmp	al,	';'
	jz	donetest
	cmp	al,	'='
	jz	donetest
	cmp	al,	'/'
	jz	donetest
	cmp	al,	cr
donetest:
	ret
test_delimiter	endp



skip_delimiter	proc		
;--------------------------------------------
;Skips leading delimiters(<>CR) 
;In : ds[si] points to string
;Out: ds[si] points to first token char or cr
;--------------------------------------------

	dec	si	
skipLP:	inc	si
	mov	al,	byte ptr ds:[si]
	cmp	al,	cr	
	jz	skipdone
	call	test_delimiter
	jz	skipLP
skipdone:
	ret			
				
skip_delimiter	endp


Code_seg ends

Data_seg segment public 'data'

child_mess		db	0ah,0dh,'Please give full qualified path to program: ','$'
param_mess		db	0ah,0dh,'Please give parameters for program        : ','$'

;external exec variables..( in exec2.asm)

extrn	child_name	:byte

extrn	len_cmndline	:byte
extrn	commandtail	:byte


error_mess		db	0ah,0dh,'Error while reading : '
error			db	?
givename_mess		db	0ah,0dh,'Please give commandline :',9,'$'
crlf			db	0ah,0dh,'$'

Data_seg ends		


END
